#!/bin/sh
INJENV="DYLD_INSERT_LIBRARIES"
FOUNDSMTH=0

for browser in Safari Firefox
do
    # if has injected dylibs
    if /usr/bin/defaults read "/Applications/$browser.app/Contents/Info" LSEnvironment 2>/dev/null | grep -q $INJENV
    then
        FOUNDSMTH=1
    fi
done

# global env
if /bin/launchctl export | grep -q $INJENV
then
    FOUNDSMTH=1
fi

# current user's env
if /usr/bin/defaults read $HOME/.MacOSX/environment $INJENV >/dev/null 2>&1
then
    FOUNDSMTH=1
fi

for plist in `ls $HOME/Library/LaunchAgents/*.plist 2>/dev/null`
do
    MAYBEBIN=`/usr/libexec/PlistBuddy -c "Print :ProgramArguments:0" "$plist"`
    if /usr/bin/basename "$MAYBEBIN" 2>/dev/null | grep -q '^\.'
    then
        FOUNDSMTH=1
    fi
done

if test $FOUNDSMTH -ne 0
then
    echo "Infected files have been found."
else
    echo "No infection has been detected."
fi

exit $FOUNDSMTH

