#!/bin/sh
INJENV="DYLD_INSERT_LIBRARIES"
FOUNDSMTH=0

# user's env
if sudo -u $USER /bin/launchctl export | grep -q $INJENV
then
    FOUNDSMTH=1
    sudo -u $USER /bin/launchctl unsetenv $INJENV
fi

# browsers
for browser in Safari Firefox
do
    # if has injected dylibs
    if /usr/bin/defaults read "/Applications/$browser.app/Contents/Info" LSEnvironment 2>/dev/null | grep -q $INJENV
    then
        FOUNDSMTH=1

        # colon-separated list
        for dylib in `/usr/bin/defaults read "/Applications/$browser.app/Contents/Info" LSEnvironment 2>/dev/null | grep $INJENV | awk '{print$3}' | sed -e 's/^"//' -e 's/;$//' -e 's/"$//' -e 's/:/ /g'`
        do
            # hidden dylibs
            if /usr/bin/basename $dylib | grep -q '^\.'
            then
                # detection 'criteria'
                if test "`/usr/bin/file -b "$dylib" 2>/dev/null | head -1`" = "Mach-O universal binary with 2 architectures"
                then
                    # delete this file
                    /bin/rm -f "$dylib"
                fi
            fi 
        done

        # delete injection env
        /usr/libexec/PlistBuddy -c "Delete :LSEnvironment:$INJENV" "/Applications/$browser.app/Contents/Info.plist" >/dev/null 2>&1
    fi
done

# current user's env
if /usr/bin/defaults read $HOME/.MacOSX/environment $INJENV >/dev/null 2>&1
then
    FOUNDSMTH=1
    sudo -u $USER /usr/libexec/PlistBuddy -c "Delete :$INJENV" $HOME/.MacOSX/environment.plist >/dev/null 2>&1
fi

for plist in `ls $HOME/Library/LaunchAgents/*.plist 2>/dev/null`
do
    MAYBEBIN=`/usr/libexec/PlistBuddy -c "Print :ProgramArguments:0" "$plist"`
    if /usr/bin/basename "$MAYBEBIN" 2>/dev/null | grep -q '^\.'
    then
        FOUNDSMTH=1
        sudo -u $USER /bin/launchctl unload "$plist" 2>/dev/null
        /bin/rm -f "$MAYBEBIN"
        /bin/rm -f "$plist"
    fi
done

if test $FOUNDSMTH -ne 0
then
    echo "Infected files have been found and removed. Please reboot this machine."
else
    echo "No infection has been detected."
fi

exit $FOUNDSMTH
